#include "csapp.h"

typedef struct {
  sem_t ready;
  int val;
} mailbox;

#define NUM_MAILBOXES 4
static mailbox boxes[NUM_MAILBOXES];

static void *go(void *arg) {
  int from = *(int *)arg;
  int to = (from + 1) % NUM_MAILBOXES;

  boxes[to].val = from;
  V(&boxes[to].ready);

  P(&boxes[from].ready);
  printf("%d", boxes[from].val);

  return NULL;
}

int main() {
  pthread_t th[NUM_MAILBOXES];
  int i, *pi;

  for (i = 0; i < NUM_MAILBOXES; i++)
    Sem_init(&boxes[i].ready, 0, 0);

  for (i = 0; i < NUM_MAILBOXES; i++) {
    pi = malloc(sizeof(int));
    *pi = i;
    Pthread_create(&th[i], NULL, go, pi);
  }

  for (i = 0; i < NUM_MAILBOXES; i++)
    Pthread_join(th[i], NULL);

  return 0;
}
